from __future__ import print_function
import h5py


# data for which lattice to load ((un)comment appropriatly):
filename = 'diamond_DMFT.h5'
filename = 'cubic_DMFT.h5'
filename = 'hypercubic_DMFT.h5'
filename = 'hyperdiamond_DMFT.h5'
                          
with  h5py.File(filename, "r") as f:
    
    print('\nSimulations for betas:')
    betas = f['parameter']['beta'][...]
    print('',betas)
    
    for ib in betas:
        print('\nTRIQS parameters of last DMFT iteration for beta = '+str(ib)+' (same for all U values)\n')
        for ii in f['beta'+str(ib)]['parameter']:
            print('',ii, f['beta'+str(ib)]['parameter'][ii][...])
        numberOfSets = len(f['beta'+str(ib)]['history']['n_loops'])

        print('\n Simulation done in '+str(numberOfSets)+' sets with each ')
        for ii in range(numberOfSets):
            print(' ',f['beta'+str(ib)]['history']['n_loops'][ii],end='')
        print('\n loops. The sets have been done with n_meas = ')
        for ii in range(numberOfSets):
            print(' ',f['beta'+str(ib)]['history']['n_meas'][ii],end='')
        print('\n and n_warm = ')
        for ii in range(numberOfSets):
            print(' ',f['beta'+str(ib)]['history']['n_warm'][ii],end='')
        print('\n running on')
        for ii in range(numberOfSets):
            print(' ',f['beta'+str(ib)]['history']['n_procs'][ii],end='')
        print('\n cores.')
        
            
    print('\nAvailable data:')
    for key in f['beta'+str(betas[0])]['data']:
        descrString = f['beta'+str(betas[0])]['data'][key].attrs['description'].decode('UTF-8')
        print('',key+': '+descrString)
    
    # example to access the occupancy, double occupancy, self energy, and 
    # the non-interacting density of states for beta = 20
    
    nn = f['beta20/data/nn'][...]
    nUp = f['beta20/data/n_up'][...]
    nDn = f['beta20/data/n_down'][...]
    u = f['beta20/data/nn'].attrs['axis1_U'][...]
    beta = f['beta20/parameter/beta'][...]
    siw = f['beta20/data/siw'][...]
    iw = f['beta20/data/siw'].attrs['axis2_iw'][...]
    
    eps = f['beta20/data/dos/eps'][...]
    dos = f['beta20/data/dos/rho'][...]
    
# uncomment the following part to plot the u dependent 
# double occupation, magnetization, a selected self energy,
# and the noninteracting density of states

## index to select for which U the self energy is plotted    
#plotU = 19 
#    
#import matplotlib.pyplot as plt
#import numpy as np
#plt.figure(1)
#plt.title('beta t = '+str(beta))
#plt.plot(u,np.abs(nUp-nDn),'-x')
#plt.xlabel('U/t')
#plt.ylabel('magnetization')
#
#plt.figure(2)
#plt.title('beta t = '+str(beta))
#plt.plot(u,nn,'-x')
#plt.xlabel('U/t')
#plt.ylabel('double occupancy')
#
#plt.figure(3)
#
#plt.title('beta t = '+str(beta)+', U/t='+str(u[plotU]))
#plt.plot(iw,siw[plotU,:,0].imag,'-x',label='up')
#plt.plot(iw,siw[plotU,:,1].imag,'-o',label='down')
#plt.xlabel('iwn')
#plt.ylabel('Imag(Sigma)')
#plt.legend()
#
#plt.figure(4)
#plt.title('beta t = '+str(beta)+', U/t='+str(u[plotU]))
#plt.plot(iw,siw[plotU,:,0].real,'-x',label='up')
#plt.plot(iw,siw[plotU,:,1].real,'-o',label='down')
#plt.xlabel('iwn')
#plt.ylabel('Real(Sigma)')
#plt.legend()
#
#plt.figure(5)
#plt.plot(eps,dos,'-')
#plt.xlabel('w')
#plt.ylabel('Noninteracting DOS')
#
#plt.show()

    